<script lang="ts" setup>
/**
 * This Customer Logos component takes in certain themes that change how styling is handled.
 * 'dark-mode': 'Trusted by' text would be white, with all logos having a brightness + inversion filter on them that makes them white
 * 'color': Is the default mode. This keeps all logos as their default look.
 * 'mono-dark': All logos having a brightness + inversion filter on them that makes them white
 */

import type { BaseImage } from '@/types/base';

interface CustomerLogosProps {
  text?: string;
  config?: {
    aos?: {
      dataAos: string;
      duration: string;
      offset: string;
    };
    theme?: 'dark-mode' | 'color' | 'mono-dark';
  };
  logos: Array<BaseImage & { company?: string }>;
}

defineProps<CustomerLogosProps>();
</script>

<template>
  <section>
    <SlpContainer>
      <section class="customer-logos" :class="config?.theme || 'color'">
        <div
          class="customer-logos__companies slp-flex"
          :data-aos="config?.aos?.dataAos || ''"
          :data-aos-duration="config?.aos?.duration || ''"
          :data-aos-offset="config?.aos?.offset || ''"
        >
          <SlpTypography v-if="text" tag="h2" variant="body2" class="slp-my-24 customer-logos__trusted-by">
            {{ text }}
          </SlpTypography>
          <template v-for="logo in logos" :key="logo.company || logo.altText">
            <component
              :is="logo.config?.href ? 'a' : 'div'"
              :id="logo.company || logo.altText"
              :aria-label="logo.company || logo.altText"
              class="logo"
              :href="logo.config?.href || undefined"
              :data-ga-name="logo.config?.dataGaName || `${logo.company?.toLowerCase()} logo`"
              :data-ga-location="logo.config?.dataGaLocation || 'body'"
            >
              <NuxtImg :src="logo.config.src" :alt="logo.altText || ''" loading="lazy" />
            </component>
          </template>
        </div>
      </section>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.customer-logos {
  margin: $spacing-64 0;
  max-width: $breakpoint-xl;

  &__trusted-by {
    max-width: 140px;
    @media (max-width: $breakpoint-md) {
      text-align: center;
      flex: 1 0 100%;
      width: 100%;
      max-width: 100%;
    }
  }

  &.dark-mode {
    background: $color-surface-700;

    &__trusted-by {
      color: $color-text-50;
    }

    &.dark-mode img {
      filter: brightness(0) invert(1);
    }
  }

  &__companies {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;
    align-items: center;
    position: relative;

    .logo {
      flex-grow: 1;
      margin: $spacing-8;
      text-align: center;

      @media (max-width: $breakpoint-md) {
        min-width: 140px;
      }

      img {
        width: 100%;
        max-width: 120px;
        max-height: 40px;
      }
    }

    @media (max-width: $breakpoint-md) {
      justify-content: space-around;
      .logo {
        width: 100px;
      }
    }
  }

  &.mono-dark img {
    filter: grayscale(100%);
  }

  @media (max-width: $breakpoint-md) {
    margin: $spacing-24 0 $spacing-48 0;

    .title {
      text-align: center;
      margin-top: $spacing-96;
    }
  }
}
</style>
